import sys
from os import fork, wait, pipe, fdopen, close

to_child = None
from_parent = None

readable_fd, writable_fd = pipe()
child_pid = fork()
if child_pid:
    close(readable_fd)
    to_child = fdopen(writable_fd, 'w', 1)
    to_child.write('hello from parent\n')
    exit_pid, exit_status = wait()
    print('parent: child ({0}) exited with {1}'.format(exit_pid, exit_status))
    to_child.close()
else:
    close(writable_fd)
    from_parent = fdopen(readable_fd, 'r', 1)
    print('child: message "{0}"'.format(from_parent.readline().rstrip('\n')))
    from_parent.close()
    sys.exit(0)
