import sys
import time
import math
from threading import Thread, current_thread
from queue import Queue

consumers_count = int(sys.argv[1]) if len(sys.argv) == 3 else 5
producers_count = int(sys.argv[2]) if len(sys.argv) == 3 else 2

def split_tasks(m, n):
    q = m // n
    for i in range(0, m, q):
        yield range(i, min(i + q, m))

task_queue = Queue()

def consumer():
    global task_queue
    while True:
        task = task_queue.get()
        print('{0}: <- {1}'.format(current_thread().name, task))
        time.sleep(0.1)
        task_queue.task_done()

def producer(tasks):
    global task_queue
    for t in tasks:
        time.sleep(0.05)
        task = 'T{0}'.format(t)
        task_queue.put(task)
        print('{0}: -> {1}'.format(current_thread().name, task))
    task_queue.join()

consumers = [Thread(target=consumer, name='C{0}'.format(i)) for i in range(consumers_count)]
producers = [Thread(target=producer, name='P{0}'.format(i), args=(tasks,)) for i, tasks in
        enumerate(split_tasks(15, producers_count))]

for c in consumers:
    c.daemon = True
    c.start()

for p in producers:
    p.start()

for p in producers:
    p.join()
